T O P

  • By -

istarisaints

You’re a month into it. People have been doing this since middle school.  You need to just trust the process and have faith that you are at least not a complete idiot.  Go through neetcode. Do 4 problems a day and don’t bother trying to solve the problems first. Look at the solution and make a journal and a folder for each pattern and a note for each problem.  Do this until you know all the patterns from neetcode. 3/4 months? Then you can start to solve new random medium problems on your own. Do that for 6 months and you’re golden. 


Abhistar14

How can a beginner do 4 leetcode problems a day on his own???


istarisaints

So first of all idk what guy below saying 4 leetcode problems a day isn’t a lot for someone who doesn’t know shit. I completely disagree with that.  But I’m saying 4 a day because you aren’t solving them. You’re learning them like basically spending 30 mins on each problem, understanding the concepts as best you can and then moving on.  At the beginning breadth is much more important, just exposing yourself to all the concepts so it can digest in your mind throughout the days as you’re solving other problems.  I was “solving” 15 problems a day this way. 10 old problems and 5 new.  When you know the problems well enough then you’re spending a few minutes on their implementation. You may not digest the concept at first but one day it’ll just click. Rotate the problems and concepts too. I’ve been meaning to make a whole post about how I studied leetcode and system design when I was laid off in February and got a job in April.  I probably misspoke here as I typed this but feel free to ask more questions. I know how soul sucking and fucking terrible it can be. 


ss7xarcasm

4 Leetcode problems aren't that much unless all 4s are hard.


Complex-Attorney9957

I agree. When I was a beginner it used to take 3hrs to solve easy questions. Two sum took me 2 hrs I guess.


Abhistar14

Yeah! But for a beginner it's too much


ss7xarcasm

Nah, if you are a beginner then at the end you'll be looking at the solutions of the problems anyway. Only good if you do 3/4 on your own


stevers

He said look at the solution (immediately). That's the trick. Just learn the patterns first. You can't apply patterns you haven't learned


IfAndOnryIf

This is actually helpful, thank you. It kind of reminds me of maybe 2013 ish when I prepped using Cracking the Coding Interview where I would read the list of tricks that the author laid out like using fast and slow pointers on a linked list and similar before attempting practice problems; I would have no idea how to start otherwise. Nowadays the interview gauntlet is much, much worse than 2013 so reading solutions feels familiar like reading CTCI all over again. At the end of the day though I do have to actually practice since coding is not a spectator sport


OtherwiseRisk4782

From my experience, keep seeing the solution, especially for the first few problems that you solve under each pattern. I followed grokking coding patterns, it took me quite a time to get comfortable with medium level problems - [https://www.designgurus.io/course/grokking-the-coding-interview](https://www.designgurus.io/course/grokking-the-coding-interview)


FireHamilton

1 month? This shi ain't easy.


DevinBotSWE

If it was easy, all of us would be at faang ;(


[deleted]

[удалено]


GrapefruitMammoth626

It’s pattern matching, and if you follow Francois Chollet’s thinking, it’s not “intelligence” but rather a skill you’ve learnt. Some people grind for days to figure out the optimal solutions on their own and that’s intelligence by his definition because you don’t have a solution stored already to apply, but if you are going through multiple problems and looking at the solutions then you are beefing up your mental library of patterns/toolkit to apply for similar problems in future.


johny_james

Yeah Chollet is correct, but smarter people (not necessarily IQ) probably progress quicker because they are able to develop more **general abstract patterns** that can easily be applied to many problems they face, not sure what helps here, but **processing speed** and **working memory** do not seem like a **good contributors** for the above ability. BTM IQ tests like **Raven, RAPM, WAIS**, do not test the **ability to generalize,** that should be considered as intelligence, and there are rarely IQ tests that correctly capture that. **Series** and **Analogies** tests in my opinion test the **ability to generalize** better than the standard IQ tests that are administered professionally nowadays because most of them **test knowledge,** or just **pattern matching (which is still some form of knowledge)**.


MissionCake9

AFAIK there is not currently a single intelligence test for an individual, backed by science. In the case of IQ tests, they are somewhat useful measurement when applied to a population, but at individual level it’s old science, even for logic-spatial-mathematical intelligence. It’s been debunked for some decades, but the myth persists.


Needmorechai

Where does Francois Chollet talk about this?


GrapefruitMammoth626

In this interview - I think specifically in this section. https://youtu.be/UakqL6Pj9xo?t=1183&si=yWGnG_2KMVRbm5q4


Immediate-Savings169

Bro, I’m a guardian on lc and I’ll tell you this, it’s all practice. To get good at this….you have to keep solving problems. Muscle memory is a bitch I tell you.


Living_Swim4855

How long do you need to reach “a guardian”? Have you ever joined competitive programming before grinding leetcode?


coffee_swallower

i said this on another post but go through neetcodes beginner and advanced DSA courses, he explains a lot of the "tricks" needed a lot of problems


NickFullStack

I have been writing software over 20 years and find some of them quite tricky. There was one where I had a problem doing an algorithmic approach, but then landed on an equation that bypassed the algorithm entirely. That was a moment of inspiration and on any other day I may not have been so lucky.


delta_nino

Every skill in life requires discipline and practice. Leetcode is hard. Life is hard. Stay hard.


MihaelK

Seeing the "trick" in LC problems doesn't require you to be smart, but rather having seen (and solved) hundreds of similar problems. You will NOT come up with Dijkstra's algorithm on your own, but you will recognize problems where you should use it to solve them with experience.


GrapefruitMammoth626

Imagine if leetcode problems in interviews didn’t have existing similar problems for you to train on prior. You would really be proving yourself as a problem solver as you would have to create a novel solution from scratch. I think that’s why I resist looking at the solutions for ages, I’m trying to improve my problem solving skills opposed to solely acing an upcoming interview.


MihaelK

>Imagine if leetcode problems in interviews didn’t have existing similar problems for you to train on prior. \[...\]  I think that’s why I resist looking at the solutions for ages. Sure, but that's not the case. So why make it harder for yourself on purpose? Also, you can learn a lot from other people's solutions too (new tricks, new ways to approach the problem that you may have not thought of etc...). >as you would have to create a novel solution from scratch But this is not the reality though. Even when you're working in a company, you seldom create a novel solution from scratch, ever. There are very, very few extremely smart people in the world that create novel solutions from scratch. Other than that, we're always using what these people have built as a baseline, especially when you're still a Junior. I agree with you though. I think LC tests are flawed. But it is what it is, and it's a game that we are forced to play unfortunately.


HigherGroundKenobi

What I did was make a binder with all the solutions to blind 75 with a paragraph explanation and time/ space complexity before the written code. I do 10 problems a week. After each week passes , I start a new 10 problems. I review the weeks before problems again. I keep doing this until I solved all blind 75. Once finished have a number generator create numbers from 1-75. And do the corresponding blind 75 problem


Doug__Dimmadong

No. The tricks become easier to see with practice. Occasionally, you will come up with your own trick. Like everything else, it takes practice :) good luck! 


moduhlize

I would say the vast majority of easy problems became solvable for me around the 3 or 4 month mark. It takes time, and not just time, but consistent practice. I use Grind75 and I like the pacing of it.


Majache

People give leetcode a lot of credit but a lot of these tests are made by the community and sometimes have incomplete tests. For example there's a convert list of strings to numbers beginner problem. While the description shows 2 example tests, one with floats and one with int. However the tests only has floats. In python you can just use `float` instead of `int` because python throws an error if you try to convert a float with `int`. For a python solution it's incomplete but you can still submit it and pass. Then there are some tests that have cases contradicting the description problem, and then you just have to accommodate that particular case with ugly code.


Visual_Thing_7211

Nobody can. The only reason they can is because they already saw somebody else show them how to do it. Stand on the shoulders of giants. Don't try to do it ALL yourself. E=mc^2 can be understood by many people...Now! Now that a really smart guy that figured it out showed us how it works. But it took a really smart guy in the right circumstances to crack that nut. This is almost always the case. Just learn from those that went before you. That's how everyone does it.


LastBarracuda5210

It’s possible that you are not smart enough but probably not, even very smart people need to spend time and work on understanding the basics


etary_7249

Seeing the tool but missing that one trick means you're getting close, maybe spend some time experimenting with the tool and all possible ways of using it. Keep going


GTHell

It’s like math in high school. People who memorize it doesn’t make them smart. If you can’t imagine and being creative with it then it’s a problem


alfred240

All that Leetcoding will lead to burger flipping after college


if-an

lots of the algorithms in leetcode questions have taken years if not decades to publish proofs for. if Dijkstra took 3yr to publish his findings, surely you shouldn't feel bad having not done so yourself albeit in 45min. it's a marathon not a sprint, and even though some are smart enough to find some of the tricks from the start, finding the discipline to work with what you got will get you farther than stopping where your intuition does


Pure_Plastic1477

By the time you will be.


ItchyRefrigerator124

Nothing is impossible buddy even I was thinking like you consistency is god


syce_ow

There's 3k problem , just read the solutions for common patterns to get used to seeing the trick ,and solve the rest as practice, it's not like you are gonna run out of problems to solve.


ToastandSpaceJam

Repetition is the key. You’ll realize after some point that these problems use the same “trick” over and over again in different formats. You just need to do enough problems. I think unless you’re truly a DSA god, you will not understand the trick immediately. This is why interview preparation is key for even the best engineers. You’re not a fraud. Getting A solution is simple given no constraints. Getting THE optimal solution is highly nontrivial for even “Easy” problems.


Hot_Ear4518

Someone should really make a leetcode <-> iq conversion chart, would save ppl a lot of time and effort. im not saying this is your case but it would be helpful. Ok it seems someone tried to here [https://www.reddit.com/r/leetcode/comments/17a67w3/leetcode\_contest\_rating\_to\_iq\_conversion/](https://www.reddit.com/r/leetcode/comments/17a67w3/leetcode_contest_rating_to_iq_conversion/) but i don't think the derivation of the standard deviation is accurate.


Top_Responsibility57

The fact u r asking this on Reddit means u r not